SW_VERSION_MAJOR            := $(shell git describe --tags --abbrev=0 | cut -c 2- | cut -d. -f1)
SW_VERSION_MINOR            := $(shell git describe --tags --abbrev=0 | cut -c 2- | cut -d. -f2)
SW_VERSION_REVISION         := $(shell git describe --tags --abbrev=0 | cut -c 2- | cut -d. -f3)

FW_METADATA_SIZE            := 4

# These can be overriden by target/vendor/arch/mcu etc.
BUFFER_SIZE_USB_OVER_SERIAL ?= 16
BUFFER_SIZE_I2C_TX          ?= 64
BUFFER_SIZE_UART_TX         ?= 128
BUFFER_SIZE_UART_RX         ?= 128
BUFFER_SIZE_BLE_MIDI_PACKET ?= 128
MIDI_SYSEX_ARRAY_SIZE       ?= 100
# tinyusb only
BUFFER_SIZE_USB_MIDI_TX     ?= 4096
BUFFER_SIZE_USB_MIDI_RX     ?= 4096
BUFFER_SIZE_USB_CDC_TX      ?= 2048
BUFFER_SIZE_USB_CDC_RX      ?= 2048

DEFINES += \
BUFFER_SIZE_USB_OVER_SERIAL=$(BUFFER_SIZE_USB_OVER_SERIAL) \
BUFFER_SIZE_TSCREEN_CDC_PASSTHROUGH=$(BUFFER_SIZE_USB_OVER_SERIAL) \
BUFFER_SIZE_I2C_TX=$(BUFFER_SIZE_I2C_TX) \
MIDI_SYSEX_ARRAY_SIZE=$(MIDI_SYSEX_ARRAY_SIZE) \
BUFFER_SIZE_BLE_MIDI_PACKET=$(BUFFER_SIZE_BLE_MIDI_PACKET) \
SW_VERSION_MAJOR=$(SW_VERSION_MAJOR) \
SW_VERSION_MINOR=$(SW_VERSION_MINOR) \
SW_VERSION_REVISION=$(SW_VERSION_REVISION) \
BUFFER_SIZE_USB_MIDI_TX=$(BUFFER_SIZE_USB_MIDI_TX) \
BUFFER_SIZE_USB_MIDI_RX=$(BUFFER_SIZE_USB_MIDI_RX) \
BUFFER_SIZE_USB_CDC_TX=$(BUFFER_SIZE_USB_CDC_TX) \
BUFFER_SIZE_USB_CDC_RX=$(BUFFER_SIZE_USB_CDC_RX) \
BUFFER_SIZE_UART_TX=$(BUFFER_SIZE_UART_TX) \
BUFFER_SIZE_UART_RX=$(BUFFER_SIZE_UART_RX)

ifeq ($(DEBUG), 1)
    DEFINES += DEBUG
endif

ifeq ($(LOG), 1)
    DEFINES += USE_LOGGER
endif

ifneq (,$(findstring USE_TINYUSB,$(DEFINES)))
    DEFINES += \
    BOARD_USE_UPDATE_HOOKS
endif

DEFINES += CORE_MCU_FLASH_SIZE_USER=$(CORE_MCU_FLASH_SIZE_USER)
DEFINES += CORE_MCU_FLASH_START_ADDR_USER=$(FLASH_START_ADDR)
DEFINES += FLASH_ADDR_BOOT_START=$(FLASH_ADDR_BOOT_START)
DEFINES += FLASH_ADDR_APP_START=$(FLASH_ADDR_APP_START)
DEFINES += FLASH_ADDR_FW_METADATA=$(FLASH_ADDR_FW_METADATA)